//
// 2016.05 Kyoung Shin Park 
//
#ifndef __WIN32_SHM_H__
#define __WIN32_SHM_H__

#include <Windows.h>
#include <string>

#ifndef key_t
typedef int key_t;
#endif

#define   IPC_PRIVATE     (key_t) 0  
#define   IPC_CREAT       0001000 
#define   IPC_EXCL        0002000         /* fail if key exists */
#define   IPC_RMID        10			  /* remove identifier */
#define	  S_IRUSR			1
#define	  S_IWUSR			2

using namespace std;

class CSharedMemory  
{
public:
	CSharedMemory(string name);
	HANDLE getShm(key_t key, size_t size, int shmflg);
	int cleanShm(HANDLE shmid, int cmd, struct shmid_ds *buf); 
	void * attachShm(HANDLE shmid, const void *shmaddr, int shmflg);
	int detachShm(const void *shmaddr); 
	bool isCreated() const;

private:
	string m_SharedMemoryName;
	HANDLE m_hMemory;
	bool m_Created;
};

#endif