#pragma once
#ifndef __WIN32_SEM_H__
#define __WIN32_SEM_H__

#include <Windows.h>
#include <string>

using namespace std;
#define MAX_SEM_COUNT 3

class KSemaphore
{
public:
	KSemaphore(string name);
	virtual ~KSemaphore();
	bool create(int initialCount = 1, int maxCount = 1, string name="");
	void open(string name="");
	void close();
	void lock();
	void unlock();

private:
	string m_SemaphoreName;
	HANDLE m_hKeySemaphore;
};

#endif